Index: NEMO/branches/2020/ticket_2444/doc/latex/NEMO/subfiles/apdx_DOMAINcfg.tex
===================================================================
--- NEMO/branches/2020/ticket_2444/doc/latex/NEMO/subfiles/apdx_DOMAINcfg.tex	(revision 12771)
+++ NEMO/branches/2020/ticket_2444/doc/latex/NEMO/subfiles/apdx_DOMAINcfg.tex	(revision 12772)
@@ -530,6 +530,6 @@
   If the under ice shelf seas are opened (\np{ln_isfcav}{ln\_isfcav}), the depth of the ice shelf/ocean interface has to be include in 
   the \ifile{isfdraft\_meter} file (Netcdf format). This file need to include the \ifile{isf\_draft} variable. 
-  A positive value will me an ice shelf/ocean or ice shelf bedrock interface below the reference 0m ssh. 
-  The exact shape of the ice shelf cavity (grounding line position and minimum thickness of the water column under an ice shelf, ...) can be specify in \nam{lst:namzgr_isf}.
+  A positive value will mean ice shelf/ocean or ice shelf bedrock interface below the reference 0m ssh. 
+  The exact shape of the ice shelf cavity (grounding line position and minimum thickness of the water column under an ice shelf, ...) can be specify in \nam{zgr_isf}{namzgr\_isf}.
 
 
@@ -540,5 +540,5 @@
 \end{listing}
 
-   The options available to define the shape of the under ice shelf cavities are listed in \nam{namzgr_isf}{namzgr\_isf} (\texttt{DOMAINcfg} only, \autoref{lst:namzgr_isf}).
+   The options available to define the shape of the under ice shelf cavities are listed in \nam{zgr_isf}{namzgr\_isf} (\texttt{DOMAINcfg} only, \autoref{lst:namzgr_isf}).
 
    \subsection{Model ice shelf draft definition}
@@ -556,5 +556,5 @@
    This step is needed to take into account possible small mismatch between ice shelf draft value and bathymetry value (sources are coming from different grid, different data processes, rounding error, ...).
 
-   \item{\np{rn_isfhw_min}{rn\_isfhw\_min}:} This parameter is minimum water column thickness in the cavity. 
+   \item{\np{rn_isfhw_min}{rn\_isfhw\_min}:} This parameter is the minimum water column thickness in the cavity. 
    Where the water column thickness is lower than \np{rn_isfhw_min}{rn\_isfhw\_min}, the ice shelf draft is adjusted to match this criterion. 
    If for any reason, this adjustement break the minimum ice shelf draft allowed (\np{rn_isfdep_min}{rn\_isfdep\_min}), the cell is masked.
@@ -577,5 +577,5 @@
    \end{description}
 
-   In case of steep slope and shallow water column, it likely that 2 cells are disconnected (bathymetry above its neigbourg ice shelf draft). 
+   In case of steep slope and shallow water column, it likely that 2 cells are disconnected (bathymetry above its neigbourging ice shelf draft). 
    The option \np{ln_isfconnect}{ln\_isfconnect} allow the tool to force the connection between these 2 cells.
    Some limiters in meter or levels on the digging allowed by the tool are available (respectively, \np{rn_zisfmax}{rn\_zisfmax} or \np{rn_kisfmax}{rn\_kisfmax}).
@@ -610,6 +610,6 @@
 \end{listing}
 
-The options available to define the closed seas and how closed sea net fresh water input will be redistributed by NEMO are listed in \nam{clo} (\texttt{DOMAINcfg} only, \autoref{lst:namclo}).
-The individual definition of each closed sea is managed by \np{sn_lake}{sn\_lake}. In this fields the user needs to defined:\\
+The options available to define the closed seas and how closed sea net fresh water input will be redistributed by NEMO are listed in \nam{clo} (\texttt{DOMAINcfg} only).
+The individual definition of each closed sea is managed by \np{sn_lake}{sn\_lake}. In this fields the user needs to define:\\
    \begin{description}
    \item $\bullet$    the name of the closed sea (print output purposes).
Index: NEMO/branches/2020/ticket_2444/doc/latex/NEMO/subfiles/chap_SBC.tex
===================================================================
--- NEMO/branches/2020/ticket_2444/doc/latex/NEMO/subfiles/chap_SBC.tex	(revision 12771)
+++ NEMO/branches/2020/ticket_2444/doc/latex/NEMO/subfiles/chap_SBC.tex	(revision 12772)
@@ -1218,5 +1218,5 @@
      \np{ln_isfcav_mlt}{ln\_isfcav\_mlt}\forcode{ = .true.} activates the ocean/ice shelf thermodynamics interactions at the ice shelf/ocean interface. 
      If \np{ln_isfcav_mlt}\forcode{ = .false.}, thermodynamics interactions are desctivated but the ocean dynamics inside the cavity is still active.
-     The logical flag \np{ln_isfcav}{ln\_isfcav} control wether or not the ice shelf cavities are closed. \np{ln_isfcav}{ln\_isfcav} is not defined in the namelist but in the domcfg.nc input file.\\
+     The logical flag \np{ln_isfcav}{ln\_isfcav} control whether or not the ice shelf cavities are closed. \np{ln_isfcav}{ln\_isfcav} is not defined in the namelist but in the domcfg.nc input file.\\
 
      3 options are available to represent to ice-shelf/ocean fluxes at the interface:
@@ -1272,5 +1272,5 @@
 
         where $T_b$ is the temperature at the interface, $S_b$ the salinity at the interface, $\gamma_T$ and $\gamma_S$ the exchange coefficients for temperature and salt, respectively, 
-        $S_i$ the salinity of the ice (assumedto be 0), $h_{isf}$ the ice shelf thickness, $\rho_i$ the density of the iceshelf, 
+        $S_i$ the salinity of the ice (assumed to be 0), $h_{isf}$ the ice shelf thickness, $\rho_i$ the density of the iceshelf, 
         $c_{p,i}$ the specific heat capacity of the ice, $\kappa$ the thermal diffusivity of the ice 
         and $T_s$ the atmospheric surface temperature (at the ice/air interface, assumed to be -20C). 
@@ -1303,5 +1303,5 @@
      The fluxes and friction velocity are computed using the mean temperature, salinity and velocity in the first \np{rn_htbl}{rn\_htbl} m.
      Then, the fluxes are spread over the same thickness (ie over one or several cells).
-     If \np{rn_htbl}{rn\_htbl} larger than top $e_{3}t$, there is no more direct feedback between the freezing point at the interface and the top cell temperature.
+     If \np{rn_htbl}{rn\_htbl} is larger than top $e_{3}t$, there is no more direct feedback between the freezing point at the interface and the top cell temperature.
      This can lead to super-cool temperature in the top cell under melting condition.
      If \np{rn_htbl}{rn\_htbl} smaller than top $e_{3}t$, the top boundary layer thickness is set to the top cell thickness.\\
@@ -1398,5 +1398,5 @@
   \caption[Ice shelf location and fresh water flux definition]{
     Illustration of the location where the fwf is injected and
-    whether or not the fwf is interactif or not.}
+    whether or not the fwf is interactive or not.}
   \label{fig:ISF}
 \end{figure}
@@ -1453,5 +1453,5 @@
 \item[Step 2]: a new domcfg.nc file is built using the DOMAINcfg tools.
 \item[Step 3]: NEMO run for a specific period and output the average melt rate over the period.
-\item[Step 4]: the ice sheet model run using the melt rate outputed in step 4.
+\item[Step 4]: the ice sheet model run using the melt rate outputed in step 3.
 \item[Step 5]: go back to 1.
 \end{description}
Index: NEMO/branches/2020/ticket_2444/doc/namelists/namsbc
===================================================================
--- NEMO/branches/2020/ticket_2444/doc/namelists/namsbc	(revision 12771)
+++ NEMO/branches/2020/ticket_2444/doc/namelists/namsbc	(revision 12772)
@@ -31,5 +31,4 @@
    ln_rnf      = .false.   !  runoffs                                   (T => fill namsbc_rnf)
    ln_apr_dyn  = .false.   !  Patm gradient added in ocean & ice Eqs.   (T => fill namsbc_apr )
-   ln_isf      = .false.   !  ice shelf                                 (T   => fill namsbc_isf & namsbc_iscpl)
    ln_wave     = .false.   !  Activate coupling with wave  (T => fill namsbc_wave)
    ln_cdgw     = .false.   !  Neutral drag coefficient read from wave model (T => ln_wave=.true. & fill namsbc_wave)