Index: NEMO/branches/UKMO/NEMO_4.0.1_biharmonic_GM/cfgs/SHARED/namelist_ref
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.1_biharmonic_GM/cfgs/SHARED/namelist_ref	(revision 12785)
+++ NEMO/branches/UKMO/NEMO_4.0.1_biharmonic_GM/cfgs/SHARED/namelist_ref	(revision 12788)
@@ -949,5 +949,5 @@
       !                       !  iso-neutral laplacian operator (ln_dynldf_iso=T) :
       rn_ahm_b      = 0.0         !  background eddy viscosity  [m2/s]
-   nn_bhm_ijk_t  = 0           !  space/time variation of bilaplacian GM coefficient :
+      nn_bhm_ijk_t  = 0           !  space/time variation of bilaplacian GM coefficient :
       !                             !  = 11  uniform coefficient in interior, zero top and bottom
       !                             !  = 12  linear tapering with dz to surface, zero at top and bottom
@@ -955,4 +955,5 @@
       rn_bhm_b      = 0.0         ! bilaplacian GM coefficient
       rn_bgmzcrit   = 0.0         ! critical depth for depth variation of bilaplacian GM coefficient
+      rn_bgm_msc    = 16.0        ! multiplicative parameter for Method of Stabilising Correction (BGM)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/UKMO/NEMO_4.0.1_biharmonic_GM/src/OCE/DYN/dynldf_lap_blp.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.1_biharmonic_GM/src/OCE/DYN/dynldf_lap_blp.F90	(revision 12785)
+++ NEMO/branches/UKMO/NEMO_4.0.1_biharmonic_GM/src/OCE/DYN/dynldf_lap_blp.F90	(revision 12788)
@@ -146,5 +146,5 @@
       CALL dyn_ldf_lap( kt, tmask, fmask, pub, pvb, zulap, zvlap, 1 )   
       !
-      ! Calculate ratio of bhm and avm for stabilising correction terms
+      ! Calculate zmu for stabilising correction terms
       ! and add to avm to be included in the vertical diffusion calculation later.
       zmu(:,:,:) = 0.0_wp
@@ -152,5 +152,5 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, jpim1   ! vector opt.
-               zmu(ji,jj,jk) = ( bhm(ji,jj,jk) / (avm(ji,jj,jk) + rsmall) ) * wmask(ji,jj,jk)
+               zmu(ji,jj,jk) = ( rn_bgm_msc * bhm(ji,jj,jk) / e1e2t(ji,jj) ) * wmask(ji,jj,jk)
                avm(ji,jj,jk) = avm(ji,jj,jk) + zmu(ji,jj,jk)
             ENDDO
Index: NEMO/branches/UKMO/NEMO_4.0.1_biharmonic_GM/src/OCE/LDF/ldfdyn.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.1_biharmonic_GM/src/OCE/LDF/ldfdyn.F90	(revision 12785)
+++ NEMO/branches/UKMO/NEMO_4.0.1_biharmonic_GM/src/OCE/LDF/ldfdyn.F90	(revision 12788)
@@ -55,4 +55,5 @@
    REAL(wp), PUBLIC ::   rn_bhm_b              !: lateral bi-Laplacian GM background eddy viscosity  [m4/s]
    REAL(wp), PUBLIC ::   rn_bgmzcrit           !: critical depth (>=0) for linear tapering of bi-Lap. GM coef. to zero at surface [m] 
+   REAL(wp), PUBLIC ::   rn_bgm_msc            !: multiplicative parameter for Method of Stabilising Correction: zero = no correction term.
    !                                    !!* Parameter to control the type of lateral viscous operator
    INTEGER, PARAMETER, PUBLIC ::   np_ERROR  =-10                       !: error in setting the operator
@@ -125,5 +126,5 @@
          &                 ln_dynldf_lev, ln_dynldf_hor, ln_dynldf_iso,   &   ! acting direction of the operator
          &                 nn_ahm_ijk_t , rn_Uv    , rn_Lv,   rn_ahm_b,   &   ! lateral eddy coefficient
-         &                 nn_bhm_ijk_t, rn_bhm_b, rn_bgmzcrit,           &   ! lateral bi-Lap. GM coefficient
+         &                 nn_bhm_ijk_t, rn_bhm_b, rn_bgmzcrit, rn_bgm_msc, & ! lateral bi-Lap. GM coefficient
          &                 rn_csmc      , rn_minfac    , rn_maxfac            ! Smagorinsky settings
       !!----------------------------------------------------------------------
@@ -150,4 +151,5 @@
          WRITE(numout,*) '         bi-Laplacian GM operator             ln_dynldf_bgm = ', ln_dynldf_bgm
          WRITE(numout,*) '         critical depth for taper (if used)   rn_bgmzcrit   = ', rn_bgmzcrit
+         WRITE(numout,*) '         MSC parameter                        rn_bgm_msc    = ', rn_bgm_msc
          !
          WRITE(numout,*) '      direction of action :'